diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
index bed996f35..d489910d2 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
@@ -2,11 +2,11 @@ package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.TerrainParticle;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.GuiModelViewer;
-import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
-import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.ModelViewerScreen;
+import net.minecraft.client.gui.modelviewer.elements.ListSelectorButtonElement;
+import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
@@ -27,12 +27,12 @@ public class BlockFXEntry extends GenericFXEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
-        List<GuiButton> buttonList = super.getEntryButtons(mc, parentScreen);
-        GuiTextCycle<Integer> blockIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, buttonList.get(buttonList.size()-1).getY() + 21, 120, 20, blockId) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen) {
+        List<ButtonElement> buttonList = super.getEntryButtons(mc, parentScreen);
+        TextCycleElement<Integer> blockIdCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, buttonList.get(buttonList.size()-1).getY() + 21, 120, 20, blockId) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
-                return GuiModelViewer.cycleBlockId(current, offset);
+                return ModelViewerScreen.cycleBlockId(current, offset);
             }
 
             @Override
@@ -54,7 +54,7 @@ public class BlockFXEntry extends GenericFXEntry{
         blockIdCycle.setOnValueChanged(() -> blockId = blockIdCycle.getCurrentElement());
         buttonList.add(blockIdCycle);
 
-        GuiTextCycle<Integer> metaCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, blockIdCycle.getY() + 21, 120, 20, 0) {
+        TextCycleElement<Integer> metaCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, blockIdCycle.getY() + 21, 120, 20, 0) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
                 return (current + offset) & 0x3FFF;
@@ -79,7 +79,7 @@ public class BlockFXEntry extends GenericFXEntry{
         metaCycle.setOnValueChanged(() -> meta = metaCycle.getCurrentElement());
         buttonList.add(metaCycle);
 
-        GuiListSelectorButton<Side> sideButton = new GuiListSelectorButton<Side>(-1, -120, metaCycle.getY() + 21, 120, 20, I18n.getInstance().translateKey("model.category.particle.block.side"), Arrays.asList(Side.sides), side) {
+        ListSelectorButtonElement<Side> sideButton = new ListSelectorButtonElement<Side>(-1, -120, metaCycle.getY() + 21, 120, 20, I18n.getInstance().translateKey("model.category.particle.block.side"), Arrays.asList(Side.sides), side) {
             @Override
             public String getNameFromElement(Side element) {
                 return element.name();
@@ -93,7 +93,7 @@ public class BlockFXEntry extends GenericFXEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new TerrainParticle(world, x, y, z, motionX,motionY,motionZ, Block.getBlock(blockId), side.getId(), meta));
+        mc.particleEngine.add(new TerrainParticle(world, x, y, z, motionX,motionY,motionZ, Block.getBlock(blockId), side, meta));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java
index c76bebe6b..8cda62029 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java
@@ -10,6 +10,6 @@ public class BubbleFXEntry extends GenericFXEntry{
     }
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new BubbleParticle(world, x, y, z, motionX, motionY, motionZ, false));
+        mc.particleEngine.add(new BubbleParticle(world, x, y, z, motionX, motionY, motionZ, false));
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java
index 3d0c226e3..2f13bd2a1 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/GenericFXEntry.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
@@ -36,30 +36,30 @@ public class GenericFXEntry extends ParticleEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
-        List<GuiButton> buttons = new ArrayList<>();
-        GuiListenerTextField mxField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, 0, 120, 20, String.valueOf(motionX), "Motion X");
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen) {
+        List<ButtonElement> buttons = new ArrayList<>();
+        ListenerTextFieldElement mxField = new ListenerTextFieldElement(parentScreen, mc.font, -120, 0, 120, 20, String.valueOf(motionX), "Motion X");
         mxField.setPrefaceText("Motion X: ");
         mxField.setOnValueChanged(() ->{
             try {
                 motionX = Double.parseDouble(mxField.getText());
             } catch (Exception ignored){}
         });
-        GuiListenerTextField myField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, mxField.yPosition + 21, 120, 20, String.valueOf(motionY), "Motion Y");
+        ListenerTextFieldElement myField = new ListenerTextFieldElement(parentScreen, mc.font, -120, mxField.yPosition + 21, 120, 20, String.valueOf(motionY), "Motion Y");
         myField.setPrefaceText("Motion Y: ");
         myField.setOnValueChanged(() ->{
             try {
                 motionY = Double.parseDouble(myField.getText());
             } catch (Exception ignored){}
         });
-        GuiListenerTextField mzField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, myField.yPosition + 21, 120, 20, String.valueOf(motionZ), "Motion Z");
+        ListenerTextFieldElement mzField = new ListenerTextFieldElement(parentScreen, mc.font, -120, myField.yPosition + 21, 120, 20, String.valueOf(motionZ), "Motion Z");
         mzField.setPrefaceText("Motion Z: ");
         mzField.setOnValueChanged(() ->{
             try {
                 motionZ = Double.parseDouble(mzField.getText());
             } catch (Exception ignored){}
         });
-        GuiListenerTextField dataField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, mzField.yPosition + 21, 120, 20, String.valueOf(data), "Data");
+        ListenerTextFieldElement dataField = new ListenerTextFieldElement(parentScreen, mc.font, -120, mzField.yPosition + 21, 120, 20, String.valueOf(data), "Data");
         dataField.setPrefaceText("Data: ");
         dataField.setKeyListener(key -> {
             try {
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java
index d2f3e95e3..3eccd4c66 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java
@@ -2,9 +2,9 @@ package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.BreakingItemParticle;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
@@ -22,8 +22,8 @@ public class ItemFXEntry extends ParticleEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
-        GuiTextCycle<Integer> itemIdCycle = new GuiTextCycle<Integer>(parentScreen, mc.fontRenderer, - 120, 0, 120, 20, itemID) {
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen) {
+        TextCycleElement<Integer> itemIdCycle = new TextCycleElement<Integer>(parentScreen, mc.font, - 120, 0, 120, 20, itemID) {
             @Override
             public Integer cycleElement(Integer current, int offset) {
                 return cycleItemId(current, offset);
@@ -46,7 +46,7 @@ public class ItemFXEntry extends ParticleEntry{
         itemIdCycle.textField.setPrefaceText("ID: ");
         itemIdCycle.textField.setPlaceholder("Item ID");
         itemIdCycle.setOnValueChanged(() -> itemID = itemIdCycle.getCurrentElement());
-        return new ArrayList<GuiButton>(){
+        return new ArrayList<ButtonElement>(){
             {
                 add(itemIdCycle);
             }
@@ -55,7 +55,7 @@ public class ItemFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new BreakingItemParticle(world, x, y, z, Item.itemsList[itemID]));
+        mc.particleEngine.add(new BreakingItemParticle(world, x, y, z, Item.itemsList[itemID]));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java
index 0481e5c19..294a3da4a 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java
@@ -10,6 +10,6 @@ public class LeafFXEntry extends GenericFXEntry{
     }
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new LeafParticle(world, x, y, z, motionX, motionY, motionZ));
+        mc.particleEngine.add(new LeafParticle(world, x, y, z, motionX, motionY, motionZ));
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
index b5eac2d72..4eddd1569 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
@@ -2,9 +2,9 @@ package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.NoteParticle;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
@@ -20,13 +20,13 @@ public class NoteFXEntry extends ParticleEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
-        GuiListenerSlider noteSlider = new GuiListenerSlider(-1, -120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.particle.note.slider", getNoteString(note)), ((float)note)/maxNote);
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen) {
+        ListenerSliderElement noteSlider = new ListenerSliderElement(-1, -120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.particle.note.slider", getNoteString(note)), ((float)note)/maxNote);
         noteSlider.setOnValueChanged(() ->{
             note = (int) (noteSlider.sliderValue * maxNote);
             noteSlider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.particle.note.slider", getNoteString(note));
         });
-        return new ArrayList<GuiButton>(){{add(noteSlider);}};
+        return new ArrayList<ButtonElement>(){{add(noteSlider);}};
     }
     private String getNoteString(int note){
         return (Integer.toHexString(note).length() == 1) ? "0"+Integer.toHexString(note) : Integer.toHexString(note);
@@ -34,7 +34,7 @@ public class NoteFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new NoteParticle(world, x, y, z, (double) note / 24D, 0.0D, 0.0D));
+        mc.particleEngine.add(new NoteParticle(world, x, y, z, (double) note / 24D, 0.0D, 0.0D));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntry.java
index 95d6b8a76..57480939a 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntry.java
@@ -1,8 +1,8 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
@@ -10,7 +10,7 @@ import java.util.List;
 
 public abstract class ParticleEntry {
     public abstract String getParticleName(I18n translator);
-    public abstract List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen);
+    public abstract List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen);
     public abstract void spawnParticle(Minecraft mc, World world, double x, double y, double z);
     public abstract void onOpen();
     public abstract void onClose();
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
index de87b4c6d..056c5797a 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
@@ -2,9 +2,9 @@ package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.particle.RedstoneDustParticle;
-import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiScreen;
-import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.modelviewer.elements.ListenerTextFieldElement;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
@@ -22,8 +22,8 @@ public class RedDustFXEntry extends ParticleEntry{
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen) {
-        GuiListenerTextField rField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -120, 0, 40, 20, String.valueOf(red), "Red");
+    public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen) {
+        ListenerTextFieldElement rField = new ListenerTextFieldElement(parentScreen, mc.font, -120, 0, 40, 20, String.valueOf(red), "Red");
         rField.setPrefaceText("R: ");
         rField.setKeyListener(key -> {
             try {
@@ -36,7 +36,7 @@ public class RedDustFXEntry extends ParticleEntry{
                 red = 0;
             }
         });
-        GuiListenerTextField gField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -80, 0, 40, 20, String.valueOf(green), "Green");
+        ListenerTextFieldElement gField = new ListenerTextFieldElement(parentScreen, mc.font, -80, 0, 40, 20, String.valueOf(green), "Green");
         gField.setPrefaceText("G: ");
         gField.setKeyListener(key -> {
             try {
@@ -49,7 +49,7 @@ public class RedDustFXEntry extends ParticleEntry{
                 green = 0;
             }
         });
-        GuiListenerTextField bField = new GuiListenerTextField(parentScreen, mc.fontRenderer, -40, 0, 40, 20, String.valueOf(blue), "Blue");
+        ListenerTextFieldElement bField = new ListenerTextFieldElement(parentScreen, mc.font, -40, 0, 40, 20, String.valueOf(blue), "Blue");
         bField.setPrefaceText("B: ");
         bField.setKeyListener(key -> {
             try {
@@ -62,7 +62,7 @@ public class RedDustFXEntry extends ParticleEntry{
                 blue = 0;
             }
         });
-        return new ArrayList<GuiButton>(){{
+        return new ArrayList<ButtonElement>(){{
             add(rField);
             add(gField);
             add(bField);
@@ -71,7 +71,7 @@ public class RedDustFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new RedstoneDustParticle(world, x, y, z, red/255f, green/255f, blue/255f, 15));
+        mc.particleEngine.add(new RedstoneDustParticle(world, x, y, z, red/255f, green/255f, blue/255f, 15));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListSelectorButton.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListSelectorButtonElement.java
similarity index 85%
rename from src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListSelectorButton.java
rename to src/main/java/net/minecraft/client/gui/modelviewer/elements/ListSelectorButtonElement.java
index 5d7bb9166..57ac2e8e8 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListSelectorButton.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListSelectorButtonElement.java
@@ -7,12 +7,12 @@ import java.util.ArrayList;
 import java.util.Collection;
 import java.util.List;
 
-public abstract class GuiListSelectorButton<T> extends GuiListenerButton{
+public abstract class ListSelectorButtonElement<T> extends ListenerButtonElement {
     public final List<T> list;
     private int index;
     private final String formattedText;
     private final T defaultElement;
-    public GuiListSelectorButton(int id, int xPosition, int yPosition, int width, int height, String formattedText, Collection<T> collection, T initialElement) {
+    public ListSelectorButtonElement(int id, int xPosition, int yPosition, int width, int height, String formattedText, Collection<T> collection, T initialElement) {
         super(id, xPosition, yPosition, width, height, "");
         displayString = String.format(formattedText, getNameFromElement(initialElement));
         this.defaultElement = initialElement;
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerButtonElement.java
similarity index 69%
rename from src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java
rename to src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerButtonElement.java
index 331e21c69..4c26e2401 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerButtonElement.java
@@ -1,17 +1,17 @@
 package net.minecraft.client.gui.modelviewer.elements;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiButton;
+import net.minecraft.client.gui.ButtonElement;
 
-public class GuiListenerButton extends GuiButton implements IListenerElement<GuiListenerButton> {
+public class ListenerButtonElement extends ButtonElement implements IListenerElement<ListenerButtonElement> {
     protected IActionListener action;
     protected IKeyListener keyListener;
     protected Runnable onValueChanged;
-    public GuiListenerButton(int id, int xPosition, int yPosition, String text) {
+    public ListenerButtonElement(int id, int xPosition, int yPosition, String text) {
         super(id, xPosition, yPosition, text);
     }
 
-    public GuiListenerButton(int id, int xPosition, int yPosition, int width, int height, String text) {
+    public ListenerButtonElement(int id, int xPosition, int yPosition, int width, int height, String text) {
         super(id, xPosition, yPosition, width, height, text);
     }
     @Override
@@ -29,18 +29,18 @@ public class GuiListenerButton extends GuiButton implements IListenerElement<Gui
         }
     }
     @Override
-    public GuiListenerButton setActionListener(IActionListener listener) {
+    public ListenerButtonElement setActionListener(IActionListener listener) {
         action = listener;
         return this;
     }
 
     @Override
-    public GuiListenerButton setKeyListener(IKeyListener listener) {
+    public ListenerButtonElement setKeyListener(IKeyListener listener) {
         keyListener = listener;
         return this;
     }
     @Override
-    public GuiListenerButton setOnValueChanged(Runnable runnable){
+    public ListenerButtonElement setOnValueChanged(Runnable runnable){
         onValueChanged = runnable;
         return this;
     }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerSliderElement.java
similarity index 68%
rename from src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java
rename to src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerSliderElement.java
index 1b54b47cf..2b88be8b7 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/ListenerSliderElement.java
@@ -1,22 +1,22 @@
 package net.minecraft.client.gui.modelviewer.elements;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.GuiSlider;
+import net.minecraft.client.gui.SliderElement;
 import net.minecraft.client.option.FloatOption;
 
-public class GuiListenerSlider extends GuiSlider implements IListenerElement<GuiListenerSlider> {
+public class ListenerSliderElement extends SliderElement implements IListenerElement<ListenerSliderElement> {
     private IActionListener action;
     private IKeyListener keyListener;
     private Runnable onValueChanged;
-    public GuiListenerSlider(int id, int xPosition, int yPosition, FloatOption floatOption) {
+    public ListenerSliderElement(int id, int xPosition, int yPosition, FloatOption floatOption) {
         super(id, xPosition, yPosition, floatOption);
     }
 
-    public GuiListenerSlider(int id, int xPosition, int yPosition, int width, int height, FloatOption floatOption) {
+    public ListenerSliderElement(int id, int xPosition, int yPosition, int width, int height, FloatOption floatOption) {
         super(id, xPosition, yPosition, width, height, floatOption);
     }
 
-    public GuiListenerSlider(int id, int xPosition, int yPosition, int width, int height, String text, float defaultValue) {
+    public ListenerSliderElement(int id, int xPosition, int yPosition, int width, int height, String text, float defaultValue) {
         super(id, xPosition, yPosition, width, height, text, defaultValue);
     }
     @Override
@@ -41,18 +41,18 @@ public class GuiListenerSlider extends GuiSlider implements IListenerElement<Gui
     }
 
     @Override
-    public GuiListenerSlider setActionListener(IActionListener listener) {
+    public ListenerSliderElement setActionListener(IActionListener listener) {
         action = listener;
         return this;
     }
 
     @Override
-    public GuiListenerSlider setKeyListener(IKeyListener listener) {
+    public ListenerSliderElement setKeyListener(IKeyListener listener) {
         keyListener = listener;
         return this;
     }
     @Override
-    public GuiListenerSlider setOnValueChanged(Runnable runnable){
+    public ListenerSliderElement setOnValueChanged(Runnable runnable){
         onValueChanged = runnable;
         return this;
     }
